#ifndef BISON_PARSER_TAB_H
# define BISON_PARSER_TAB_H

#ifndef YYSTYPE
typedef union {
    token                *tok;

    token_list           *toks; 

    node                 *n_node;
    tpd_node             *n_tpd;
    block_node           *n_block; 
    stmt_node            *n_stmt; 
    decl_node            *n_decl; 
    expr_node            *n_expr; 
    expr_group_node      *n_grp; 

    write_param_node     *n_wrtp; 
    write_list_node      *n_wrls; 
    case_node            *n_case; 
    set_item_node        *n_item; 

    const_def_node       *n_cdef; 
    type_def_node        *n_tdef; 
    var_decl_node        *n_vdcl; 

    field_init_node      *n_field;
    
    param_list_node      *n_plist; 
    idx_node             *n_idx; 

    field_list_node      *n_fldls;
    variant_part_node    *n_varp;
    selector_node        *n_sel; 
    variant_node         *n_vari;
    compound_node        *n_comp;
   
    import_list_node     *n_imp; 
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	ARRAY	257
# define	BEGIN	258
# define	CASE	259
# define	CONST	260
# define	DO	261
# define	DOTS	262
# define	ELSE	263
# define	END	264
# define	FIL	265
# define	FAR	266
# define	FOR	267
# define	FUNCTION	268
# define	GOTO	269
# define	IDENT	270
# define	ICONST	271
# define	IF	272
# define	IMPLEMENTATION	273
# define	INTERFACE	274
# define	LABEL	275
# define	LOOPHOLE	276
# define	OBJECT	277
# define	OF	278
# define	ORIGIN	279
# define	OTHERWISE	280
# define	PACKED	281
# define	PROCEDURE	282
# define	PROGRAM	283
# define	RCONST	284
# define	READ	285
# define	RECORD	286
# define	REPEAT	287
# define	RETURN	288
# define	SET	289
# define	SCONST	290
# define	STRING	291
# define	THEN	292
# define	TO	293
# define	TYPE	294
# define	UNTIL	295
# define	UNIT	296
# define	UNIT_END	297
# define	VAR	298
# define	WHILE	299
# define	WITH	300
# define	WRITE	301
# define	SCOPE	302
# define	LET	303
# define	LETADD	304
# define	LETSUB	305
# define	LETDIV	306
# define	LETMUL	307
# define	LETAND	308
# define	LETOR	309
# define	LETSHL	310
# define	LETSHR	311
# define	EQ	312
# define	NE	313
# define	LT	314
# define	LE	315
# define	GT	316
# define	GE	317
# define	IN	318
# define	PLUS	319
# define	MINUS	320
# define	OR	321
# define	XOR	322
# define	MOD	323
# define	DIV	324
# define	DIVR	325
# define	MUL	326
# define	AND	327
# define	SHR	328
# define	SHL	329
# define	UPLUS	330
# define	UMINUS	331
# define	NOT	332
# define	ADDRESS	333


extern YYSTYPE zzlval;

#endif /* not BISON_PARSER_TAB_H */
